;improvement of the limiTED2 512 bytes compo entry 
;production by gerliczer 2009.05.01.
;made in Csabo's Plus4IDE
;upload to strictly 264 series related sites only

	ORG $1001-2
	DW  $1001
	;
	DW $100B,0
	DB $9E,"4109",0,0,0
	;
LONGER  EQU 1		; 0 - only prespective correction / non 0 - also longer display area

dest    EQU $2000	; pointer of depacked text data

scroptr	EQU $e5		; first displayed line of above mentioned data
scroidx EQU $e6		; relative index of displayed line from scroptr
srcptrl EQU $e7		; source pointer low byte
srcptrh EQU $e8		; source pointer high byte
incidx1	EQU $e9		; table index for perspective correction
incidx2	EQU $ea		; table index for vertical streching
dstptrl EQU $d9		; destination pointer low byte
dstptrh EQU $da		; destination pointer high byte
tempvar EQU $d8
DELTAX	EQU $e0		; width of destination row
DELTAY	EQU $e1		; width of source row (always 8)
ERROR	EQU $e2		; auxiliary variables for _bresenh_ routine
X0	EQU $e3
Y0	EQU $e4

	JSR $f30b	; screen setup
	DEC $ff0c
	DEC $ff0d
	LDX #0
	LDA #160
loop1	STA $c00,x
	STA $d00,x
	STA $e00,x
	STA $f00,x
	INX
	BNE loop1
	STX $ff19
	;
	STX scroptr	; resetting scroll variables
	STX srcptrl
	STX srcptrh
	;
loop2	LDA textidx,x	; depacking text data
	STX tempvar
	ASL A
	TAY
	JSR byt2dw
	INY
	JSR byt2dw
	LDX tempvar
	INX
	CPX #44
	BNE loop2
	JSR copydat	; duplicate text data
	;
loop3	LDA scroptr	; scrolling starts here
	STA scroidx       
	LDX #0
	STX tempvar
	STX incidx1
	if LONGER
	STX incidx2
	endif
loop4	TXA		; setting up copy destination
	ASL A
	TAX
	LDA rowstrt,x
	STA dstptrl
	INX
	LDA rowstrt,x
	STA dstptrh
	LDA #0		; setting up scroll source
	STA srcptrh
	LDA scroidx
	STA srcptrl
	ASL srcptrl
	ROL srcptrh
	ASL srcptrl
	ROL srcptrh
	ASL srcptrl
	ROL srcptrh
	LDA #dest>>8
	CLC
	ADC srcptrh
	STA srcptrh
	;
	JSR bresenh 	; come Mr. Bresenham strech us a bit
	;
	LDY incidx1	; correcting perspective
	LDA perspc,y	; with LUT
	BEQ skip1
	INC scroidx
skip1	INC incidx1
	if LONGER
	LDY incidx2	; streching vertically
	LDA width,y	; with LUT
	BEQ skip2
	INC tempvar
skip2	INC incidx2
	LDX incidx2
	CPX #25		; repeat 25 times
	else
	INC tempvar
	LDX tempvar
	CPX #17		; repeat 17 times
	endif
	BNE loop4
	LDY #40		; delay
loop5	LDX #255
	DEX
	BNE *-1
	DEY
	BNE loop5
	INC scroptr	; scroll length: 44 "pixel" columns
	LDA scroptr
	CMP #44
	BNE loop3
	LDA #0
	STA scroptr
	JMP loop3
	;
byt2dw	LDA textdat,y	; depacker
	STA dstptrl
	LDX #4
loopa1	LDA #0
	ASL dstptrl
	ROL A
	ASL dstptrl
	ROL A
store	STA dest
	LDA store+1
	INC store+1
	BNE skipa1
	INC store+2
skipa1	DEX
	BNE loopa1
	RTS
	;
copydat LDA store+1	; duplicator
	STA copy+1
	LDA store+2
	STA copy+2
src	LDA dest
copy	STA $ffff
	INC src+1
	BNE skipb1
	INC src+2
skipb1	INC copy+1
	BNE skipb2
	INC copy+2
skipb2	LDA src+1
	CMP store+1
	BNE src
	LDA src+2
	CMP store+2
	BNE src
	RTS
	;
bresenh	LDA tempvar	; strecher fashioned after the Bresenham line algorithm
	ASL A
	CLC
	ADC #7
	STA DELTAX
	LSR A
	STA ERROR
	LDA #7
	STA DELTAY
	LDY #0
	STY X0
	STY Y0
loopc1	LDY Y0
	LDA (srcptrl),y
	TAX
	LDA textcls,x
	LDY X0
	STA (dstptrl),y
	LDA ERROR
	SEC
	SBC DELTAY
	STA ERROR
	BPL skipc1
	INC Y0
	LDA ERROR
	CLC
	ADC DELTAX
	STA ERROR
skipc1	INC X0
	LDA X0
	CMP DELTAX
	BNE loopc1
	RTS
	;
	; more text and colours for Exin :)
	; packed text data as indexes
textidx	DB  7,  1,  0,  2,  0,  3,  4,  5,  4,  5,  0,  2,  0 , 6,  6,  7,  6,  6,  0,  7,  8,  8
	DB  9,  9,  0,  7,  9,  9,  0, 10,  0, 11, 12, 12, 13, 14,  0, 15, 16, 16, 17, 17, 18,  0
	;
	; packed text data indexed chunks
textdat	DB $00, $00
	DB $40, $00
	DB $55, $10
	DB $55, $00
	DB $01, $00
	DB $54, $00
	DB $00, $04
	DB $55, $54
	DB $41, $04
	DB $40, $04
	DB $15, $50
	DB $a0, $20
	DB $88, $08
	DB $82, $08
	DB $80, $a0
	DB $3f, $f0
	DB $c0, $0c
	DB $28, $f0
	DB $20, $30
	;
	; displayed colours
textcls	DB $10, $71, $32, $16
	;
	; pointers to starting positions of used row areas
	if LONGER
rowstrt	DW $802+16+ 0*39+ 0*40, $802+16+ 1*39+ 0*40, $802+16+ 1*39+ 1*40, $802+16+ 2*39+ 1*40
	DW $802+16+ 3*39+ 1*40, $802+16+ 3*39+ 2*40, $802+16+ 4*39+ 2*40, $802+16+ 5*39+ 2*40
	DW $802+16+ 5*39+ 3*40, $802+16+ 6*39+ 3*40, $802+16+ 7*39+ 3*40, $802+16+ 7*39+ 4*40
	DW $802+16+ 8*39+ 4*40, $802+16+ 9*39+ 4*40, $802+16+ 9*39+ 5*40, $802+16+10*39+ 5*40
	DW $802+16+11*39+ 5*40, $802+16+11*39+ 6*40, $802+16+12*39+ 6*40, $802+16+13*39+ 6*40
	DW $802+16+13*39+ 7*40, $802+16+14*39+ 7*40, $802+16+15*39+ 7*40, $802+16+15*39+ 8*40
	DW $802+16+16*39+ 8*40
	else
rowstrt	DW $8b1, $8d8, $8ff, $926
	DW $94d, $974, $99b, $9c2
	DW $9e9, $a10, $a37, $a5e
	DW $a85, $aac, $ad3, $afa
	DW $b21
	endif
	;
	if !LONGER
perspc	DB 1, 1, 1, 1
	DB 1, 0, 1, 0
	DB 0, 1, 0, 0
	DB 0, 0, 0, 0
	else
perspc	DB 1, 1, 0, 1
	DB 0, 1, 0, 1
	DB 0, 0, 0, 1
	DB 0, 0, 0, 1
	DB 0, 0, 0, 1
	DB 0, 0, 0, 0
	DB 1
	;
width	DB 1, 0, 1, 1
	DB 0, 1, 1, 0
	DB 1, 1, 0, 1
	DB 1, 0, 1, 1
	DB 0, 1, 1, 0
	DB 1, 1, 0, 1
	DB 1
	endif
